/** 
* @file LabeledFileList.h
* @brief reads images from directory
* @author Erik Rodner
* @date 17.09.2007
*/
#ifndef LabeledFileListINCLUDE
#define LabeledFileListINCLUDE

#include <string>

#include "core/basics/Config.h"
#include "vislearning/baselib/ProgressBar.h"

#include "ClassNames.h"
#include "LocalizationResult.h"
#include "LabeledSet.h"

namespace OBJREC {

/** reads images from directory */
class LabeledFileList
{
    private:
	bool debug_dataset;

    public:
  
	/** simple constructor */
	LabeledFileList(); 
      
	/** simple destructor */
	virtual ~LabeledFileList();
 
	LocalizationResult *getLocalizationInfo ( const ClassNames & classnames,
					    int classno,
					    const std::string & file,
					    const NICE::Config & conf ) const;

	void get ( const std::string & dir,
		   const NICE::Config & datasetconf,
		   const ClassNames & classnames, 
		   LabeledSet & ls,
		   bool localizationInfoDisabled = false,
		   bool debugDataset = false );
		   
	void getFromPattern ( const std::string & dir,
		   const NICE::Config & datasetconf,
		   const ClassNames & classnames, 
		   LabeledSet & ls,
		   bool localizationInfoDisabled = false ) const;

	void getFromList ( const std::string & filelist,
		   const NICE::Config & datasetconf,
		   const ClassNames & classnames, 
		   LabeledSet & ls,
		   bool localizationInfoDisabled = false ) const;

};


} // namespace

#endif
