/*!
 * \file Polygon.h
 * \brief
 * \author Gapchich Vladislav
 * \date 23/10/11
 */

#ifndef __POLYGON_H__
#define __POLYGON_H__

#include "core/image/CoordT.h"
#include <list>

using namespace NICE;

typedef std::list< CoordT< int > > PointsList;

namespace OBJREC {

//! \brief Contains category ID and point list of the polygon
class Polygon
{
public:
	Polygon();
	Polygon(const Polygon &copy);
	~Polygon();
	
	void push(const CoordT< int > &aPoint);
	void push(const int &x, const int &y);
	void setID(const int &anID);
	
	const PointsList * points() const;
	CoordT< int > pop();
	int id() const;
	
private:
	PointsList points_;
	int id_;
};

} //namespace

#endif /* __POLYGON_H__ */

/*
 * 
 */
