/** 
* @file GenericImageTools.h
* @brief simple filter stuff
* @author Erik Rodner
* @date 07/30/2008

*/
#ifndef GENERICIMAGETOOLSINCLUDE
#define GENERICIMAGETOOLSINCLUDE

#include "core/image/MultiChannelImageT.h"


namespace OBJREC {

/** simple filter stuff */
class GenericImageTools 
{
    public:

    template <class PixelValueDst, class PixelValueSrc>
    static void calcIntegralImage ( PixelValueDst *integral, const PixelValueSrc *image, int xsize, int ysize );

    template <class PixelValueDst, class PixelValueSrc>
    static void nonMaximumSuppression ( PixelValueDst *dst, const PixelValueSrc *src, int xsize, int ysize, bool useEightConnectivity = true );

};

#include "GenericImageTools.tcc"
 

} // namespace

#endif
